#ifndef __CDiagonalMatrix__
#define __CDiagonalMatrix__
#include "CMatrix.h"
//insert required exception headers
#include
#include <iostream>

using namespace std;
// 
// update the method signatures
// example:
// void j() throw (OutOfBoundsException,NegativeIndexException);
//  

class CDiagonalMatrix : public CMatrix {
private:
	int numberOfCols;
public :
	CDiagonalMatrix();
	~CDiagonalMatrix();
	CDiagonalMatrix(const CDiagonalMatrix&);
	CDiagonalMatrix(int, int, double = 0.0);
	CDiagonalMatrix& operator~() const;
	CVector& operator[](int) const;
	CDiagonalMatrix& operator=(const CDiagonalMatrix&) ;
	CDiagonalMatrix& operator+(const CDiagonalMatrix&) const;
	CDiagonalMatrix& operator-(const CDiagonalMatrix&) const;
	CDiagonalMatrix& operator-() const;
	CDiagonalMatrix& operator/(double divisor) const;
	CDiagonalMatrix& operator*(const CDiagonalMatrix&) const;
	double& operator()(int, int) const;
	CDiagonalMatrix& clone() const ;
	friend ostream& operator <<(ostream&, const CDiagonalMatrix&);
} ;
#endif
